/***********************************************************************
 * authors : BOURDAIS Christelle & MARION Virginie
 *                    University of RENNES I          
 * 
 ***********************************************************************/
#include <stdio.h>
#include <math.h>


typedef double Vec[3];


   
MakeVector(x, y, z, v)
 double x, y, z ;
 Vec v ;
{
	v[0] = x ; v[1] = y ; v[2] = z ;
}

VecNegate(v)
 Vec v ;
{
	v[0] = -v[0] ;
	v[1] = -v[1] ;
	v[2] = -v[2] ;
}

 
double VecDot(a, b)
 Vec a, b ;
{      
	return(a[0] * b[0] + a[1] * b[1] + a[2] * b[2]) ;
}

double VecLen(a)
 Vec a;
{        
   	return sqrt(VecDot(a,a)) ; 
}

VecCopy(a, b) 
 Vec a, b ;
{
	b[0] = a[0] ;
	b[1] = a[1] ;
	b[2] = a[2] ;
}

VecAdd(a, b, c)
 Vec a, b, c ;
{
	c[0] = a[0] + b[0] ;
	c[1] = a[1] + b[1] ;
	c[2] = a[2] + b[2] ;
}

VecSub(a, b, c)
 Vec a, b, c ;
{
	c[0] = a[0] - b[0] ;
	c[1] = a[1] - b[1] ;
	c[2] = a[2] - b[2] ;
}

VecComb(A, a, B, b, c)
 double A, B ;
 Vec a, b, c ;
{
	c[0] = A * a[0] + B * b[0] ;	
	c[1] = A * a[1] + B * b[1] ;	
	c[2] = A * a[2] + B * b[2] ;	
}

VecAddS(A, a, b, c)
 double A ;
 Vec a, b, c ;
{
	c[0] = A * a[0] + b[0] ;	
	c[1] = A * a[1] + b[1] ;	
	c[2] = A * a[2] + b[2] ;	
}

VecCross(a, b, c)
 Vec a, b, c ;
{
	c[0] = a[1] * b[2] - a[2] * b[1] ;
	c[1] = a[2] * b[0] - a[0] * b[2] ;
	c[2] = a[0] * b[1] - a[1] * b[0] ;
}
double VecNormalize(vec)
  Vec vec ;
{
	double len ;
	len = (double) VecLen(vec);
	vec[0]/=len ;
	vec[1]/=len ;
	vec[2]/=len ;
	return(len) ;
}


int NormeVecMin(v1,v2)
   Vec v1,v2;
{
   double n1,n2;
   
   n1=VecLen(v1);
   n2=VecLen(v2);
  
   if (n1>n2) return((int)n2);
   return((int)n1);   
   
} 

