#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>

struct tms      buf1, buf2;
int             chronorunning = 0;

extern void      exit();

void StartChrono(mess)
     char       *mess;
{
    if (chronorunning) 
    {
	fprintf(stderr, "chrono already running, error at %s\n",mess);
	exit(-1);
    }
    fprintf(stderr,"\n######################################\r");
    fprintf(stderr,"##### %s \n",mess);
    chronorunning = 1;
    times(&buf1);
}

void StopChrono()
{
    times(&buf2);
    buf2.tms_utime -= buf1.tms_utime;
    buf2.tms_stime -= buf1.tms_stime;
    buf2.tms_utime /= 60;
    buf2.tms_stime /= 60;
    fprintf(stderr,"user code             %4d min %3d sec\n",
	    buf2.tms_utime / 60, buf2.tms_utime % 60);
    fprintf(stderr,"system code           %4d min %3d sec\n",
	    buf2.tms_stime / 60, buf2.tms_stime % 60);
    fprintf(stderr,"######################################\n\n");
    chronorunning = 0;
}
